﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WebApi.Data.People
{
	public class Person : Aggregate
	{
		internal String FirstName { get; private set; }
		internal String LastName { get; private set; }

		private Person()
		{

		}

		Person SetupCompleted()
		{
			this.RaiseEvent( new Events.PersonCreated( this.Id, this.FirstName, this.LastName ) );

			return this;
		}

		public class Factory 
		{
			public Person CreatePerson( string firstName, string lastName )
			{
				var person = new Person()
				{
					Id = "people/" + Guid.NewGuid().ToString(),
					FirstName = firstName,
					LastName = lastName
				};

				return person.SetupCompleted();
			}
		}
	}
}
