﻿define(['durandal/http', 'durandal/system'],
    function (http, system) {
        var history = function () {
            var self = this;

            self.displayName = 'History.';

            self.http = http;

            self.results = ko.observableArray();
        };

        history.prototype.viewAttached = function () {
            var self = this;
            self.refresh();
        };

        history.prototype.refresh = function () {
            var self = this;

            self.results.removeAll();

            http.get('/api/history')
                        .then(function (r) {
                            for (i = 0; i < r.results.length; i++) {
                                var result = r.results[i];
                                system.log(result);
                                self.results.push(result);
                            }
                        });
        };

        return history;
    });