﻿(function (module) {
    var backend = function ($log, $rootScope, $http, $q) {

        var svc = {

            history: function () {
                $log.debug('history');

                var deferred = $q.defer();

                var uri = '/api/history';
                $log.debug('history: [uri]', uri);

                $http.get(uri)
                    .success(function (data, status, headers, config) {

                        $log.debug('history executed:', data, status, headers, config);
                        deferred.resolve(data);

                    });

                $log.debug('server called, waiting for the promise.');

                return deferred.promise;
            },

            search: function (query, pageIndex, pageSize) {

                $log.debug('search: [query, pageIndex, pageSize]', query, pageIndex, pageSize);

                var deferred = $q.defer();

                var uri = '/api/search?q=' + query;
                if (pageIndex) {
                    uri += '&p=' + pageIndex.toString();
                }
                if (pageSize) {
                    uri += '&s=' + pageSize.toString();
                }

                $log.debug('search: [uri]', uri);

                $http.get(uri)
                    .success(function (data, status, headers, config) {

                        $log.debug('search executed:', data, status, headers, config);
                        deferred.resolve(data);

                    });

                $log.debug('server called, waiting for the promise.');

                return deferred.promise;
            },

            getItem: function (id, collection) {
                $log.debug('getItem: [id, collection]', id, collection);

                var deferred = $q.defer();

                var uri = '/api/' + collection + '/?id=' + collection + '/' + id;
                $log.debug('getItem: [uri]', uri);

                $http.get(uri)
                    .success(function (data, status, headers, config) {

                        $log.debug('getItem executed:', data, status, headers, config);
                        deferred.resolve(data);

                    });

                $log.debug('server called, waiting for the promise.');

                return deferred.promise;
            }
        };

        return svc;
    };
    backend.$inject = ['$log', '$rootScope', '$http', '$q'];

    module.factory('backendService', backend);

}(angular.module('my.services')));