﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Optimization;

namespace WebApiServer
{
	public class BundleConfig
	{
		// For more information on Bundling, visit http://go.microsoft.com/fwlink/?LinkId=254725
		public static void RegisterBundles( BundleCollection bundles )
		{
			bundles.Add( new ScriptBundle( "~/bundles/jquery" )
				.Include( "~/Scripts/jquery-{version}.js" )
				.Include( "~/Scripts/jquery.ba-throttle-debounce*" )
				.Include( "~/Scripts/jquery.signalR-{version}.js" ) );

			bundles.Add( new ScriptBundle( "~/bundles/jqueryui" ).Include(
						"~/Scripts/jquery-ui-{version}.js" ) );

			bundles.Add( new ScriptBundle( "~/bundles/jqueryval" ).Include(
						"~/Scripts/jquery.unobtrusive*",
						"~/Scripts/jquery.validate*" ) );

			bundles.Add( new ScriptBundle( "~/bundles/bootstrap" ).Include(
						"~/Scripts/bootstrap.min.js" ) );

			bundles.Add( new ScriptBundle( "~/bundles/angular" ).Include(
						"~/Scripts/enquire.min.js",
						"~/Scripts/angular.js",
						"~/Scripts/angular-ui-router.js",
						"~/Scripts/angular-ui-utils.min.js" ) );

			bundles.Add( new ScriptBundle( "~/bundles/app" ).Include(
							"~/app/modulesDefinitions.js",
							"~/app/services/*.js",
							"~/app/appModule.js",
							"~/app/directives/*.js",
							"~/app/presentation/*.js"
							) );

			// Use the development version of Modernizr to develop with and learn from. Then, when you're
			// ready for production, use the build tool at http://modernizr.com to pick only the tests you need.
			bundles.Add( new ScriptBundle( "~/bundles/modernizr" ).Include(
						"~/Scripts/modernizr-*" ) );

			bundles.Add( new StyleBundle( "~/Content/css" ).Include(
						"~/Content/bootstrap/bootstrap.min.css",
						"~/Content/bootstrap/bootstrap-glyphicons.css",
						"~/Content/Site.css" ) );

			bundles.Add( new StyleBundle( "~/Content/themes/base/css" ).Include(
						"~/Content/themes/base/jquery.ui.core.css",
						"~/Content/themes/base/jquery.ui.resizable.css",
						"~/Content/themes/base/jquery.ui.selectable.css",
						"~/Content/themes/base/jquery.ui.accordion.css",
						"~/Content/themes/base/jquery.ui.autocomplete.css",
						"~/Content/themes/base/jquery.ui.button.css",
						"~/Content/themes/base/jquery.ui.dialog.css",
						"~/Content/themes/base/jquery.ui.slider.css",
						"~/Content/themes/base/jquery.ui.tabs.css",
						"~/Content/themes/base/jquery.ui.datepicker.css",
						"~/Content/themes/base/jquery.ui.progressbar.css",
						"~/Content/themes/base/jquery.ui.theme.css" ) );
		}
	}
}